#!/usr/bin/perl -w
#
# Copyright (C) 2008 Patrick Fuerlinger
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# 20080801 pf initial
#
#//////////////////////////////////////////////////////////////////////////////
use FindBin qw ( $Bin );
use lib "$Bin/../lib/";
use strict;
use warnings;
use ReelBox::Base qw(vdr_status get_config get_bookmark);
use Getopt::Long;

my $g_ConfigTemplate  = '/opt/rbc/htdocs/config/reelbox.cfg.tmpl';
my $g_Config          = '/opt/rbc/htdocs/config/reelbox.cfg';
my $g_BookMrkTemplate = '/opt/rbc/htdocs/config/bookmark.cfg.tmpl';
my $g_BookMrkConfig   = '/opt/rbc/htdocs/config/bookmark.cfg';

my %g_CFG;
my $g_Debug;

sub GetArgs;
sub exit_handler;
sub main;

#//////////////////////////////////////////////////////////////////////////////
# funtions
sub GetArgs {
  my $help;

  GetOptions( "--debug" => \$g_Debug,
              "--write" => \$g_CFG{'write'},
              "--help"  => \$g_CFG{'help'});

}
#//////////////////////////////////////////////////////////////////////////////
sub main {
  my %CONF_TMPL=%{get_config($g_ConfigTemplate)};
  my %CONF=%{get_config($g_Config)} if (-e $g_Config);

  GetArgs;


  open(NEW, "> $g_Config")  if (defined $g_CFG{'write'});
    foreach (keys %CONF_TMPL) {
      chomp;
      $CONF_TMPL{$_} = $CONF{$_} if (defined $CONF{$_} && $_ ne 'rbc_version');
      $CONF_TMPL{$_} = $CONF{'AvantgardeIP'}
        if ( $_ eq 'ip_address' && defined $CONF{'AvantgardeIP'} );
      print "$_ = $CONF_TMPL{$_}\n" if $g_Debug;
      print NEW "$_=$CONF_TMPL{$_}\n" if (defined $g_CFG{'write'});
    }
  close(NEW) if (defined $g_CFG{'write'});


  %CONF = ();
  %CONF_TMPL = ();
  %CONF_TMPL = %{get_bookmark($g_BookMrkTemplate)};
  %CONF      = %{get_bookmark($g_BookMrkConfig)} if (-e $g_BookMrkConfig);

  open(NEW, "> $g_BookMrkConfig")  if (defined $g_CFG{'write'});
    foreach my $b (reverse sort keys %CONF) {
      chomp($b);

      $b = 'http://reelboxcenter.ch' if $b =~ /golinux.ch/;

      if ( defined $CONF_TMPL{$b} ) {
        print NEW "$b $CONF_TMPL{$b}\n" if (defined $g_CFG{'write'});
        print "$b $CONF_TMPL{$b}\n" if $g_Debug;

      } else {
        print NEW "$b\n" if (defined $g_CFG{'write'});
        print "$b\n" if $g_Debug;

      }
    }
  close(NEW) if (defined $g_CFG{'write'});
}
#//////////////////////////////////////////////////////////////////////////////

main;