#!/usr/bin/perl -w

use strict;
use File::Basename;


my @INCS = glob('/opt/rbc/htdocs/i18n/*.inc');
my @LANGUAGES;
my %LANG;

## read files
foreach my $inc (@INCS) {
  chomp($inc);
  ( my $sfx = basename($inc) ) =~ s/\.inc//;
  push ( @LANGUAGES, $sfx) if $sfx ne 'de';

  open( FILE, "< $inc" ) or die;
  foreach (<FILE>) {
    chomp;
    next if /^\s*#/ || /^\s*$/;
    ## print "$_\n";
    if ( /(.+)\...=(.+)/ ) {
      $LANG{$sfx}{$1} = $2;
    }
  }
  close(FILE);
}

foreach my $l ( @LANGUAGES ) {
  foreach my $word ( sort keys %{ $LANG{'de'} } ) {
    if ( !defined $LANG{$l}{$word} || $LANG{$l}{$word} eq '' ) {
     print "$l: Missing '$word' ( de=$LANG{'de'}{$word} )\n";
    }
  }
  print "\n";
}